=== debian/changelog ===
simgrid (3.17+dfsg-1) unstable; urgency=medium

  * New upstream release (Drained Leaks). Changes since 3.16:
    - Many many internal cleanups (almost 700 commits since 3.16).
    - The coverage of our tests is above 80%.
    - All memleaks but one plugged; A dozen of bugs fixed.
    - XBT: Further replace XBT with std::* constructs.
  * d/p/atomic-library: drop (integrated upstream).
  * d/control: Bump standard version to 4.1.1 (no change required)

 -- Martin Quinson <mquinson@debian.org>  Mon, 09 Oct 2017 07:45:55 +0200
